with Reps, Reps.Ops, Reps.IO, Messages, RG, RG.Beltrami, Ada.Numerics.Generic_Elementary_Functions,Ada.Characters.Latin_1, Round_Up,Numerics, Numerics.Ops, Numerics.IO;
with CoNumbers, CoNumbers.Ops, CoNumbers.IO, Ada.Text_IO,Ada.Float_Text_IO, GetOpt, Ada.Command_Line,Ada.Strings.Unbounded;
use Reps, Reps.Ops, Reps.IO, Messages, Numerics, Numerics.Ops, Numerics.IO,CoNumbers, CoNumbers.Ops, CoNumbers.IO, Ada.Text_IO,Ada.Float_Text_IO, GetOpt, Ada.Command_Line, Ada.Strings.Unbounded;

pragma Elaborate_All(Numerics.Ops);
pragma Elaborate_All(CoNumbers.Ops,CoNumbers.IO);
pragma Elaborate_All(Reps.Ops);
pragma Elaborate_All (RG);

procedure Approx_Sol is

   pragma Suppress(Storage_Check);

   Pdeg:constant Positive:=2000;
   Dho: constant Natural:=2000;
   subtype Scalar is Numeric;
   subtype Comp is CoNumber;

   package Current_RG is new RG(Pdeg,Dho,Scalar,Comp);
   use Current_RG,Current_RG.RG_Tay,Current_RG.RG_Tay_Ops,Current_RG.RG_Tay_IO,Current_RG.RG_Lin;

   package Current_Beltrami is new Current_RG.Beltrami;
   use Current_Beltrami;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;

   Pex: constant Rep:=Rep(2.2);
   Test_String : String := "l:g:h:b:x:i:k:t:o:q:r:y:e:f:c:d:p:z:";
   Roo,NumErr: Rep;
   FT,Read_B,Cut_Output,Write_H,Read_A,Write_B,Va,Iter,K,Np1,Np2,Num_Of_Machines_Bel,This_Machine: Integer;
   Optchar : character;
   Tay_File,Out_Dir: Unbounded_String;
   Read_Beltrami,Read_Approx,Write_Sol,Write_Beltrami: Boolean;
   ShowErr: Boolean;
   GetPoly: constant Boolean:=True;
   Decimal: constant Boolean:=False;
   FFT: Boolean:=False;
begin
   --DEAFULT OPTION
   K:=1;
   This_Machine:=1;
   Iter:=100;
   Write_B:=1;
   Read_B:=1;
   Read_A:=0; --do not read approximation
   Write_H:=1; --save inside the iteration cycle
   Cut_Output:=6;
   Out_Dir:=To_Unbounded_String("/home/gaidash/numerics_data/");
   Tay_File:=To_Unbounded_String("/home/gaidash/numerics_data/taylor");
   NumErr:=Rep(1.0E-5);
   Rho:=Two;

   --OPTIONS
   Getopt.Opterr := 1;
   loop
      Va := Getopt.Getopt( Test_String );
      exit when Va = -1;
      optchar :=  Character'Val( Va );
      case optchar is
         when 'o' =>
            Out_Dir:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'f' =>
            Tay_File:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'l' =>
            Cut_Output:=Integer'Value(To_String(Getopt.Optarg));
         when 'z' =>
            FT:=Integer'Value(To_String(Getopt.Optarg));
         when 'g' =>
            Read_A:=Integer'Value(To_String(Getopt.Optarg));
         when 'h' =>
            Write_H:=Integer'Value(To_String(Getopt.Optarg));
         when 'y' =>
            Read_B:=Integer'Value(To_String(Getopt.Optarg));
         when 'b' =>
            Write_B:=Integer'Value(To_String(Getopt.Optarg));
         when 'x' =>
            Num_Of_Machines_Bel:=Integer'Value(To_String(Getopt.Optarg));
         when 'i' =>
            Iter:=Integer'Value(To_String(Getopt.Optarg));
         when 't' =>
            This_Machine:=Integer'Value(To_String(Getopt.Optarg));
         when 'e' =>
            NumErr:=Rep'Value(To_String(Getopt.Optarg));
         when 'k' =>
            K:=Integer'Value(To_String(Getopt.Optarg));
         when others =>
            New_Line;
            Message("Wrong option in Approx_Sol",Parameter_Error);
      end case;
   end loop;

   --UPDATING OPTIONS
   if FT=1 then
      FFT:=True;
   elsif Read_A=0 then
      FFT:=False;
   else
      New_Line;
      Message("Wrong option in Approx_Sol",Parameter_Error);
   end if;
   if Read_A=1 then
      Read_Approx:=True;
   elsif Read_A=0 then
      Read_Approx:=False;
   else
      New_Line;
      Message("Wrong option in Approx_Sol",Parameter_Error);
   end if;
   if Read_B=1 then
      Read_Beltrami:=True;
   elsif Read_B=0 then
      Read_Beltrami:=False;
   else
      New_Line;
      Message("Wrong option in Approx_Sol",Parameter_Error);
   end if;
   if Write_H=1 then
      Write_Sol:=True;
   elsif Write_H=0 then
      Write_Sol:=False;
   else
      New_Line;
      Message("Wrong option in Approx_Sol",Parameter_Error);
   end if;
   if Write_B=1 then
      Write_Beltrami:=True;
   elsif Write_B=0 then
      Write_Beltrami:=False;
   else
      New_Line;
      Message("Wrong option in Approx_Sol",Parameter_Error);
   end if;

   declare
      CM: String:=Set_Machine(This_Machine,Num_Of_Machines_Bel);

      Dir: String:=To_String(Out_Dir);

      Radial_Grid: String:=Dir & "rads/radii";
      Rho_Grid: String:=Dir & "rads/rhos";

      G_Dir: String:="g/";
      H_Dir: String:="h/";
      Mult_Dir: String:="mult/";

      Con_File: String:=Dir & "con_file";

      SolZeroValue_File: String:=Dir & "points/sol_val_at_zero";
      P_File: String:=Dir & "points/periodic_point";
      Cn2_File: String:=Dir & "points/cn2_point";
      Cn2n_File: String:=Dir & "points/cn2n_point";

      G_File: String:=Dir & "g/approx_g_" & CM;
      Approx_Belt_File: String:=Dir & "beltrami/approx_belt_" & CM;
      Belt_File: String:=Dir & "beltrami/belt_" & CM;

      N1: constant Integer:=Read_N1(Radial_Grid);
      N2: constant Integer:=Read_N2(Radial_Grid);
      M: Integer:=Read_M(Radial_Grid);
      K1, K2:  Integer;

      RN1,RN2,Qnmin1,Qnmin2,Qnplus1,Qnplus2: Integer;
      F,F1,F2,F3,F4: File_Type;
      Tay: Taylor;
   begin
      New_Line;
      ShortPut(This_Machine);Put("-TH MACHINE OUT OF ");ShortPut(Num_Of_Machines_Bel);

      if FFT then
         K1:=-M/2;
         K2:=M/2-1;
      else
         M:=M+5;
         K1:=2-(M-1)/2;
         K2:=2+(M-1)/2;
      end if;

      Qnmin1:=0;
      Qn:=1;
      Qnplus1:=2;
      Qnplus2:=3;
      for I in 2..K loop
         if I=2 then
            Qnmin2:=0;
            Qnmin1:=1;
            Qn:=2;
            Qnplus1:=3;
            Qnplus2:=5;
         else
            Qnmin2:=Qnmin1;
            Qnmin1:=Qn;
            Qn:=Qnmin2+Qnmin1;
            Qnplus1:=Qn+Qnmin1;
            Qnplus2:=Qnplus1+Qn;
         end if;
      end loop;


      --READING TAYLOR
      New_Line;
      Put("Reading the fixed point ...");
      Read_P(To_String(Tay_File),One,Tay,GetPoly,Decimal);
      Put("done");

      --READING AND COMPUTING POINTS
      New_Line;
      Put("Reading points ...");
      ShowErr:=True;
      Read(P_File,P,Decimal,ShowErr);
      Read(Cn2_File,Cn2,Decimal,ShowErr);
      Read(Cn2n_File,Cn2n,Decimal,ShowErr);
      LogB:=Neg(CoI)*Log(CoOne-P/Cn2);--image of C_{n+2} under inverse tau
      LogA:=AbsVal( Log( (CoOne-P/Cn2n)/(CoOne-P/Cn2)  )  );
      LogBB:=LogB;
      Put(" done");

      --SETTING THE DIMENSIONS OF THE  ARRAYS
      if This_Machine=1 then
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=N1+This_Machine*Integer((-N1)/Num_Of_Machines_Bel)-1;
         RN1:=Np1;RN2:=Np2+1;
      elsif This_Machine=Num_Of_Machines_Bel then
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=0;
         RN1:=Np1-1;RN2:=Np2;
      else
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=N1+This_Machine*Integer((-N1)/Num_Of_Machines_Bel)-1;
         RN1:=Np1-1;RN2:=Np2+1;
      end if;


      declare
         Rad: ScalArray(RN1..RN2);
         Ro: ScalArray(RN1-1..RN2);
         Belt,H: CompMatrix(Np1..Np2,K1..K2);
      begin

         --READING THE FULL RADIAL GRID
         New_Line;
         Put("Reading the grid ...");
         Open(F,In_File,Radial_Grid);
         Open(F2,In_File,Rho_Grid);
         Set_Line(F,Ada.Text_IO.Count(2+RN1-N1));
         Set_Line(F2,Ada.Text_IO.Count(2+RN1-N1));
         for I in Rad'Range loop
            Txt_Get(F,Roo,Decimal);
            Rad(I):=Scal(Roo);
         end loop;
         for I in Ro'Range loop
            Txt_Get(F2,Roo,Decimal);
            Ro(I):=Scal(Roo);
         end loop;
         Close(F2);
         Close(F);
         Put("done");

         --DISPLAYING INFO
         New_Line;
         New_Line;
         Put("q_n=");ShortPut(Qn);
         New_Line;
         Put("p=");Show(P);
         New_Line;
         Put("ind. point=");Show(P);
         New_Line;
         Put("f^(q_(n+2))(c)=");Show(Cn2);
         New_Line;
         Put("f^(q_(n+2)+q_n)(c)=");Show(Cn2n);
         New_Line;
         Put("Iterations in T_Transfrom=");ShortPut(Iter);
         New_Line;
         Put("Minimal radius=");Txt_Put(Current_Output,Approx(Rad(Rad'First)));
         New_Line;
         Put("Maximal radius=");Txt_Put(Current_Output,Approx(Rad(Rad'Last)));
         New_Line;
         Put("Radial grid dimensions=(");ShortPut(N1);Put(",");ShortPut(N2);Put(")");
         New_Line;
         Put("Angular grid dimensions=(");ShortPut(K1);Put(",");ShortPut(K2);Put(")");
         New_Line;
         Put("Radial grid dimensions on this machine=(");ShortPut(Np1);Put(",");ShortPut(Np2);Put(")");
         New_Line;
         Put("Maximal increment on this machine=");Show(Rad(Rad'Last)-Rad(Rad'Last-1));

         Create(F,Out_File,Dir & "logs/start_" & CM);
         Put(F,0);
         Close(F);

         --READING/COMPUTING AND WRITING THE BELTRAMI DIFFERENTIAL
         if Read_Beltrami then
            New_Line;
            New_Line;
            Put("Reading the differential...");
            Read_SB(Belt,Belt_File,False,False,Decimal,ShowErr);
            Put(" done");
         else
            if This_Machine>4 then
              NumErr:=Rep(1.0E-3)*NumErr;
            end if;

            New_Line;
            New_Line;
            Put("Forming the Beltrami differential...");
            if This_Machine=1 and This_Machine<=(Num_Of_Machines_Bel) then
               BeltramiF(NumErr,Rad,Tay,Belt,FFT);
            else
               Beltrami(NumErr,Rad,Tay,Belt,FFT);
            end if;
            New_Line;
            Put(" done");
            if Write_Beltrami then
               New_Line;
               Put("Writing the Beltrami differential...");
               Write_SB(Belt,Approx_Belt_File,Decimal,ShowErr); --series
               Put(" done");
            end if;
         end if;


         Con_File:=Dir & "con_file";
         if This_Machine=1 then
            Create(F,Out_File,Con_File);
            Put(F,Iter);
            Close(F);
         end if;

         SetZero(H);

         --ITERATING



Iter_Approx_Sol(N1,Num_Of_Machines_Bel,This_Machine,Cut_Output,Iter,Belt,H,Rad,Rad,Ro,CoZero,Con_File,Dir,G_Dir,H_Dir,Mult_Dir,Read_Approx,Write_Sol,Decimal,ShowErr,FFT);
         if  This_Machine=1 then
            Write(SolZeroValue_File,H(H'First(1),0),Decimal,ShowErr);
         end if;
      end;
   end;
end Approx_Sol;



























