with Reps, Reps.Ops, Reps.IO, Messages,
Ada.Numerics.Generic_Elementary_Functions,Ada.Characters.Latin_1,Round_Up, Intervals, Intervals.Ops, Intervals.IO;
with RG, RG.Beltrami,CoBalls, CoBalls.Ops, CoBalls.IO, Ada.Text_IO,Ada.Float_Text_IO,  Ada.Command_Line, GetOpt,  Ada.Strings.Unbounded;
use Reps, Reps.Ops, Reps.IO, Messages,Intervals, Intervals.Ops, Intervals.IO, CoBalls, CoBalls.Ops, CoBalls.IO, Ada.Text_IO,Ada.Float_Text_IO, GetOpt, Ada.Command_Line, Ada.Strings.Unbounded;

pragma Elaborate_All(Intervals.Ops);
pragma Elaborate_All(CoBalls.Ops,CoBalls.IO);
pragma Elaborate_All(Reps.Ops);
pragma Elaborate_All (RG);

procedure Cauchy is

   pragma Suppress(Storage_Check);

   Pdeg:constant Positive:=3000;
   Dho: constant Natural:=3000;
   subtype Scalar is Interval;
   subtype Comp is CoBall;

   package Current_RG is new RG(Pdeg,Dho,Scalar,Comp);
   use Current_RG, Current_RG.RG_Tay, Current_RG.RG_Tay_Ops, Current_RG.RG_Tay_IO, Current_RG.RG_Lin;

   package Current_Beltrami is new Current_RG.Beltrami;
   use Current_Beltrami;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;

   Test_String : String := "x:k:o:p:r:t:c:";
   Pex: Rep;
   Co,Read_A,Np1,Np2,Va,K,Num_Of_Machines_Bel,This_Machine,Pre: Integer;
   Optchar : character;
   Out_Dir: Unbounded_String;
   ShowErr,FFT,Compute: Boolean;
   GetPoly: constant Boolean:=True;
   Decimal: constant Boolean:=False;
begin
   --DEAFULT OPTIONS
   K:=3;
   Num_Of_Machines_Bel:=2;
   This_Machine:=1;
   Read_A:=0;
   Pre:=0;
   Out_Dir:=To_Unbounded_String("/users/denis/Output/example/");
   Pex:=Rep(2.1);
   FFT:=(IsNumeric(ScalZero) and IsCoNumber(CoZero));
   Rho:=Two;

   --OPTIONS
   Getopt.Opterr := 1;
   loop
      Va := Getopt.Getopt( Test_String );
      exit when Va = -1;
      optchar :=  Character'Val( Va );
      case optchar is
         when 'o' =>
            Out_Dir:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'x' =>
            Num_Of_Machines_Bel:=Integer'Value(To_String(Getopt.Optarg));
         when 'k' =>
            K:=Integer'Value(To_String(Getopt.Optarg));
         when 'c' =>
            Co:=Integer'Value(To_String(Getopt.Optarg));
         when 't' =>
            This_Machine:=Integer'Value(To_String(Getopt.Optarg));
         when 'p' =>
            Pex:=Rep'Value(To_String(Getopt.Optarg));
         when others =>
            New_Line;
            Message("Wrong option in Cauchy",Parameter_Error);
      end case;
   end loop;

if Co=1 then
Compute:=True;
elsif Co=0 then
Compute:=False;
else
            New_Line;
            Message("Wrong Compute option in Cauchy",Parameter_Error);
end if;


   --UPDATING OPTIONS
   declare
      MM: constant Integer:=20;
      NN: constant Integer:=10;

      CM: String:=Set_Machine(This_Machine,Num_Of_Machines_Bel);
      TM: String:=Set_Machine(This_Machine-1,Num_Of_Machines_Bel);

      File_Output: constant Boolean:=False;
      Dir: String:=To_String(Out_Dir);
      Radial_Grid: String:=Dir & "rads/radii";
      VarRho_File: String:=Dir & "rads/varrho";
      RadScal_Grid: String:=Dir & "rads/thick_radii";
      Rho_Grid: String:=Dir & "rads/rhos";
      InfValue_File: String:=Dir & "points/inf_value";
      SolZeroVal_File: String:=Dir & "points/sol_val_at_zero";
      ZeroValue_File: String:=Dir & "points/zero_value";
      C_File: String:=Dir & "data/C_file_";
      A_File: String:=Dir & "data/A_file";
      EP_File: String:=Dir & "data/Eps_file_";
      R_File: String:=Dir & "data/R_file_";
      G_File: String:=Dir & "g/g_" & CM;
      Data_File: String:=Dir & "data/data_" & CM;
      Diff_Norm_File: String:=Dir & "data/diff_norm_" & Integer'Image(Num_Of_Machines_Bel)(2..Integer'Image(Num_Of_Machines_Bel)'Last);
      Roo:Rep;
      ActRad,VarRho,B,A,Radd,Psi,Cp,ConstK,VarEpsilon,Delt1,Delt2,Delt4,Delt5,ConstA,Epsilon,S1,S2,S3,S4,S5,RPrime,ConstC,C1,C2,C3,C4,C5,Qex,EpsilonPrime: Scalar;
      K1,K2,RoN2,RN1,RN2: Integer;
      InfValue,Ess1,Ess2,Ex,IEx,Cex,ICex,ZeroValue: Comp;
      F,F1,F2: File_Type;

      N1: constant Integer:=Read_N1(Radial_Grid);
      N2: constant Integer:=Read_N2(Radial_Grid);
      M: constant Integer:=Read_M(Radial_Grid)+5;
   begin
      New_Line;
      ShortPut(This_Machine);Put("-TH MACHINE OUT OF ");ShortPut(Num_Of_Machines_Bel);

      if not FFT then
         A:=Scal(Rep(2.8));
         B:=Scal(Half)+One/A;
         Qex:=Scal(Pex)/(Pex-One);
         C1:=Four*Exp((Qex-ScalOne)*Log(Sqr(A)))/(Exp(Qex*Log(A-ScalOne ))*(ScalTwo-Qex));
         C2:=Exp(Qex*Log(Sqr(A)))*Sqr(B);
         C3:=Two*Exp((Qex-ScalOne)*Log(Sqr(A)));
         C4:=Exp((ScalOne-Qex)*Log(Sqr(B)-Scal(Rep(0.25))))/(Qex-ScalOne);
         C5:=Exp(Log(C1+C2-C3+C4)/Qex);
         ConstA:=Exp(-(Log(ScalPi)/Pex))*C5;
         Cp:=(One/Sqr(Sin(Half*ScalPi/Pex))-ScalOne);
         New_Line;
         Put("A=");Show(ConstA);
         Put("Cp=");Show(Cp);
         Put("L-p EXPONENT=");Txt_Put(Current_Output,Pex);
      end if;

      --READING THE DIMENSIONS OF THE GRID
      if This_Machine=1 then
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=N1+This_Machine*Integer((-N1)/Num_Of_Machines_Bel)-1;
         RN1:=Np1;RN2:=Np2+1;RoN2:=RN2;
      elsif This_Machine=Num_Of_Machines_Bel then
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=0;
         RN1:=Np1-1;RN2:=N2;RoN2:=0;
      else
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=N1+This_Machine*Integer((-N1)/Num_Of_Machines_Bel)-1;
         RN1:=Np1-1;RN2:=Np2+1;RoN2:=RN2;
      end if;
      if not FFT then
         K1:=2-(M-1)/2;
         K2:=(M-1)/2+2;
      else
         K1:=-M/2;
         K2:=M/2-1;
      end if;
      declare
         Rad,ThickRad: ScalArray(RN1..RN2);
         Ro: ScalArray(RN1-1..RoN2);
         H: CompMatrix(Np1..Np2,K1..K2);
         Del: constant Scalar:=ScalPi/Rep(MM*M);
      begin

         --READING THE RADIAL GRID
         New_Line;
         Put("Reading grid ...");
         Open(F,In_File,Radial_Grid);
         Open(F1,In_File,RadScal_Grid);
         Open(F2,In_File,Rho_Grid);
         Set_Line(F,Ada.Text_IO.Count(2+RN1-N1));
         Set_Line(F1,Ada.Text_IO.Count(2+RN1-N1));
         Set_Line(F2,Ada.Text_IO.Count(2+RN1-N1));
         for I in Rad'Range loop
            Txt_Get(F,Roo,Decimal);
            Rad(I):=Scal(Roo);
            Get(F1,Radd,Decimal);
            ThickRad(I):=Radd;
         end loop;
         for I in Ro'Range loop
            Txt_Get(F2,Roo,Decimal);
            Ro(I):=Scal(Roo);
         end loop;
         Close(F2);
         Close(F1);
         Close(F);
         Put("done");
         New_Line;
         Put("Radial grid dimensions on this machine=(");ShortPut(Np1);Put(",");ShortPut(Np2);Put(")");         New_Line;
         Put("Maximal radius on this machine=");Show(Rad(Np2));
         Put("Minimal radius on this machine=");Show(Rad(Np1));
         ActRad:=Scal(Inf(ThickRad(Rad'Last)));
         Create(F,Out_File,Dir & "logs/start_" & CM);

         Put(F,0);
         Close(F);

         if not FFT then
            ShowErr:=True;
            --READING AND COMPUTIGN CONSTANTS
            New_Line;
            Put("Reading data and computing constants...");
            Delt1:=ScalZero;
            Delt2:=ScalZero;
            Delt4:=ScalZero;
            Delt5:=ScalZero;
            ConstK:=ScalZero;
            VarEpsilon:=ScalZero;
            Read_P(ZeroValue_File,ZeroValue,Decimal,ShowErr);
            Read_P(InfValue_File,InfValue,Decimal,ShowErr);
            Read_P(VarRho_File,VarRho,True);
            ConstK:=Scal(SupMod(InfValue));
            for J in 1..This_Machine loop
               TM:=Set_Machine(J,Num_Of_Machines_Bel);
               Data_File:=Dir & "data/data_" & TM;
               Open(F,In_File,Data_File);
               Get(F,S1,Decimal);--p-th power of the L_p error of the Beltrami differential
               Get(F,S2,Decimal);--p-th power of the L_p error of the Beltrami differential
               Get(F,S3,Decimal);-- ConstK
               Get(F,S4,Decimal);-- L_p error in multiplication
               Close(F);
               Diff_Norm_File:=Dir & "data/diff_norm_" & TM;
               Read_P(Diff_Norm_File,S5,Decimal);--|| h*-T[(h*+1)*mu]||^p_p
               Delt1:=Delt1+S1;
               Delt2:=Delt2+S2;
               if Sup(S3)>Sup(ConstK) and J>1 then
                  ConstK:=S3;
               end if;
               Delt4:=Delt4+S4;
               Delt5:=Delt5+S5;
            end loop;
            Put("done");
            New_Line;
            Put("ess sup(mu) at this machine=");Show(S3);
            for J in This_Machine+1..Num_Of_Machines_Bel loop
               TM:=Set_Machine(J,Num_Of_Machines_Bel);
               Data_File:=Dir & "data/data_" & TM;
               Open(F,In_File,Data_File);
               Set_Line(F,Ada.Text_IO.Count(3));
               Get(F,S3,Decimal);-- ConstK
               Close(F);
               if Sup(S3)>Sup(ConstK) then
                  ConstK:=S3;
               end if;
            end loop;
            if SupMod(ZeroValue)>Sup(ConstK) then
               ConstK:=Scal(SupMod(ZeroValue));
            end if;
            ConstK:=Scal(Rep(0.58));
            --COMPUTING EPSILON - BOUND ON THE FIXED POINT
            Put("ess sup(mu) at zero=");Show(Scal(SupMod(ZeroValue)));
            Put("ess sup(mu) at infinity=");Show(Scal(SupMod(InfValue)));
            Put("ess sup(mu)=");Show(ConstK);
            Put("||(h*+1)*eta||^p_p=");Show(Delt1+Delt2);
            Put("L-p multiplication error");Show(Delt4);
            Put("||h*-T[(h*+1)*mu]||^p_p=");Show(Delt5);
            Epsilon:=Cp*(Exp(Log(Scal(Sup(Delt1+Delt2+Delt4)))/Pex)+Exp(Log(Scal(Sup(Delt5)))/Pex)+AbsVal(ZeroValue)*Exp(Log(ScalPi*Sqr(Scal(Sup(VarRho))))/Pex) )/(ScalOne-Cp*ConstK);
            Put("EPSILON=");Show(Epsilon);
            EpsilonPrime:=(Exp(Log(Scal(Sup(Delt1+Delt2+Delt4)))/Pex)+Exp(Log(Scal(Sup(Delt5)))/Pex)+AbsVal(ZeroValue)*Exp(Log(ScalPi*Sqr( Scal(Sup(VarRho))))/Pex)  )/(ScalOne-Cp*ConstK);
            Put("EPSILON'=");Show(EpsilonPrime);
         end if;

         --ITERATION
         if not FFT then
            ShowErr:=True;
         else
            ShowErr:=False;
         end if;
         if Compute then
             Iter_Cauchy(Pex,N1,Num_Of_Machines_Bel,This_Machine,Num_Of_Machines_Bel,H,Rad,ThickRad,Ro,Dir,True,Decimal,ShowErr);
             if  This_Machine=1  then
                Write(SolZeroVal_File,H(H'First(1),0),Decimal);
             end if;
             New_Line;
             Put("Writing g...");
             if not FFT then
               ShowErr:=True;
             else
               ShowErr:=False;
             end if;
             Write_SB(H,G_File,Decimal,ShowErr);
             Put(" done");
          else
             New_Line;
             Put("Reading the solution...");
             Read_SB(H,G_File,False,False,Decimal,ShowErr);
             Put("done");
          end if;

          if not FFT then
            --COMPUTING R'
               RPrime:=Scal(Rep(10.0E+20));
               Psi:=-ScalPi;
               for J in H'Range(2) loop
                  for II in 1..MM loop
                     Ex:=Exp(Scal(Inf(Psi),Sup(Psi+Del))*CoI);
                     IEx:=Exp(Neg(Scal(Inf(Psi),Sup(Psi+Del))*CoI));
                     Cex:=Ex; ICex:=IEx;
                     Ess1:=H(H'Last(1),0);
                     Ess2:=H(H'Last(1),0);
                     for I in 1..NN loop
                        Ess1:=Ess1+H(H'Last(1),I)*Cex+H(H'Last(1),-I)*ICex;
                        Ess2:=Ess2+H(H'Last(1),I)*ICex+H(H'Last(1),-I)*Cex;
                        Cex:=Cex*Ex;
                        ICex:=ICex*IEx;
                     end loop;
                     Ess1:=AbsBall(Ess1);
                     Ess2:=AbsBall(Ess2);
                     if InfMod(Ess1)<Inf(RPrime) then
                        RPrime:=AbsVal(Ess1);
                     end if;
                     if InfMod(Ess2)<Inf(RPrime) then
                        RPrime:=AbsVal(Ess2);
                     end if;
                     Psi:=Psi+Del;
                  end loop;
               end loop;
               RPrime:=RPrime-ConstA*Exp((Pex-Two)*Log(Scal(Inf(ActRad)))/Pex);
               New_Line;
               Put("R=");Show(ActRad);
               Put("R'=");Show(RPrime);

               --COMPUTING CONSTANT C
               ConstC:=C5*AbsVal(InfValue)*(ScalTwo-AbsVal(InfValue)*Cp)/(Exp(Log(Sqr(RPrime))/Pex)*(ScalOne-AbsVal(InfValue)*Cp));
               New_Line;
               Put("CONSTANT C=");Show(ConstC);

               if This_Machine=1 then
                  New_Line;
                  Put("Writing machine-independent constants...");
                  Write(A_File,ConstA,Decimal);
               end if;
               New_Line;
               Put("Writing constants...");
               Write(C_File & CM,ConstC,Decimal);
               Write(R_File & CM,RPrime,Decimal);
               Write(EP_File & CM,EpsilonPrime,Decimal);
               Put("done");

         New_Line;
         Put("C=");Show(ConstC);
         New_Line;
         Put("R'=");Show(RPrime);
         New_Line;
         Put("A=");Show(ConstA);
         New_Line;
         Put("Eps=");Show(EpsilonPrime);
         end if;
      end;
   end;
end Cauchy;



























