with Messages, Reps.IO, Ada.IO_Exceptions;
use Messages, Reps.IO;

package body CoBalls.IO is

   procedure Show(C: in CoBall; Cut: in Rep:=Zero) is
   begin
      if Re(C.C)*Re(C.C)+Im(C.C)*Im(C.C)>Cut*Cut or  C.R /= Zero  then
         Put("(");
         Txt_Put(Current_Output,Re(C.C));
         Put(",");
         Txt_Put(Current_Output,Im(C.C));
         Put(")");
         Put(" [");
         Txt_Put(Current_Output,C.R);
         Put(" ]");
      end if;
   end Show;

   procedure Show(Text: in String; C: in CoBall; Cut: in Rep:=Zero) is
   begin
      Put(Text);
      Show(C,Cut);
      New_Line;
   end Show;

   procedure Get(F: in File_Type; S: out CoBall;   Decimal: in Boolean := True; Radius: in Boolean:=False) is
      R1,R2,R3: Rep;
   begin
      if Radius then
         Txt_Get(F,R1,R2,R3,Decimal);
      else
         Txt_Get(F,R1,R2,Decimal);
         R3:=Zero;
      end if;
      S:=SetBall(Complecs(R1,R2),R3);
   end Get;

   procedure Put(F: in File_Type; S: in CoBall;   Decimal: in Boolean := True; Radius: in Boolean:=False) is
   begin
      if Radius then
         Txt_Put(F,Re(S.C),Im(S.C),S.R,Decimal);
      else
         Txt_Put(F,Re(S.C),Im(S.C),Decimal);
      end if;
   end Put;

   procedure Read(File_Name: in String; C: out CoBall;   Decimal: in Boolean := True; Radius: in Boolean:=False) is
      F: File_Type;
   begin
      Open(F,In_File,File_Name);
      Get(F,C,Decimal,Radius);
      Close(F);
   end Read;

   procedure Write(File_Name: in String; C: in CoBall;   Decimal: in Boolean := True; Radius: in Boolean:=False) is
      F: File_Type;
   begin
      Create(F,Out_File,File_Name);
      Put(F,C,Decimal,Radius);
      Close(F);
   end Write;

   procedure Read(File_Name: in String; C: out CoBall;   Decimal: in Boolean := True; Radius: in Boolean:=False; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
      F: File_Type;
   begin
      Open(F,In_File,File_Name);
      Set_Line(F,N);
      Get(F,C,Decimal,Radius);
      Close(F);
   end Read;

   procedure Read_Par(File_Name: in String; C: out CoBall;   Decimal: in Boolean := True; Radius: in Boolean:=False; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
      F: File_Type;
   begin
      if EKS=1 then
         New_Line;
         Put("Handle is not reset");Message("CoBalls.IO.Read_Par",Parameter_Error);
      end if;
      Open(F,In_File,File_Name);
      Set_Line(F,N);
      Get(F,C,Decimal,Radius);
      Close(F);
   exception
      when Ada.Text_IO.End_Error  =>
         Close(F);
         Put("handling exception...");
         EKS:=1;
         return;
      when Ada.IO_Exceptions.Data_Error =>
         Close(F);
         Put("handling exception...");
         EKS:=1;
         return;
      when Ada.IO_Exceptions.Name_Error  =>
         Put("handling exception...");
         EKS:=1;
         return;
      when  Ada.IO_Exceptions.Status_Error =>
         Close(F);
         Put("handling exception...");
         EKS:=1;
         return;
      when  Ada.IO_Exceptions.Use_Error =>
         Put("handling exception...");
         EKS:=1;
         return;
   end Read_Par;

   procedure Read_P(File_Name: in String; C: out CoBall;   Decimal: in Boolean := True; Radius: in Boolean:=False; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
      F: File_Type;
   begin
      <<REREAD>> Read_Par(File_Name,C,Decimal,Radius,N);
      if EKS=1 then
         EKS:=0;
         delay 0.01;
         goto REREAD;
      end if;
   end Read_P;

end CoBalls.IO;
