with Reps.Ops,Reps.IO, Messages,Ada.IO_Exceptions;
use Reps.Ops,Reps.IO, Messages;

package body CoNumbers.IO is


   package Txt_CoNumbers_IO is new Ada.Text_IO.Complex_IO(Complex_Typo);
   use  Txt_CoNumbers_IO;


   procedure Show(C: in CoNumber; Cut: in Rep:=Zero) is
   begin
--      if Sqrt(Sqr(Re(C))+Sqr(Im(C)))>Cut then
         Put("(");
         Txt_Put(Current_Output,Re(C));
         Put(",");
         Txt_Put(Current_Output,Im(C));
         Put(")");
--      end if;
   end Show;

   procedure Show(Text: in String; C: in CoNumber; Cut: in Rep:=Zero) is
   begin
     Put(Text);
     Show(C,Cut);
     New_Line;
   end Show;

   procedure Get(F: in File_Type; C: out CoNumber;   Decimal: in Boolean := True;ShowErr: in Boolean:=True) is
      R1,R2,R3: Rep;
   begin
      if ShowErr then
         Txt_Get(F,R1,R2,R3,Decimal);
      else
         Txt_Get(F,R1,R2,Decimal);
      end if;
      C:=SetBall(Complecs(R1,R2));
   end Get;


   procedure Put(F: in File_Type; C: in CoNumber;  Decimal: in Boolean := True; ShowErr: in Boolean:=True) is
   begin
      Txt_Put(F,Re(C),Decimal);
      Put(F," ");
      Txt_Put(F,Im(C),Decimal);
      if ShowErr then
         Txt_Put(F,Zero,Decimal);
      end if;
   end Put;

   procedure Read(File_Name: in String; C: out CoNumber;   Decimal: in Boolean := True; Radius: in Boolean:=False; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
      F:  File_Type;
   begin
      Open(F,In_File,File_Name);
      Set_Line(F,N);
      Get(F,C,Decimal,Radius);
      Close(F);
   end Read;

      procedure Read_Par(File_Name: in String; C: out CoNumber;   Decimal: in Boolean := True; Radius: in Boolean:=False; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
      F: File_Type;
   begin
      if EKS=1 then
         New_Line;
         Put("Handle is not reset");Message("CoNumbers.IO.Read_P",Parameter_Error);
      end if;
      Open(F,In_File,File_Name);
      Set_Line(F,N);
      Get(F,C,Decimal,Radius);
      Close(F);
   exception
      when Ada.Text_IO.End_Error  =>
         Close(F);
         Put("handling exception...");
         EKS:=1;
         return;
      when Ada.IO_Exceptions.Data_Error =>
         Close(F);
         Put("handling exception...");
         EKS:=1;
         return;
      when Ada.IO_Exceptions.Name_Error  =>
         Put("handling exception...");
         EKS:=1;
         return;
      when Ada.IO_Exceptions.Status_Error =>
         Close(F);
         Put("handling exception...");
         EKS:=1;
         return;
      when Ada.IO_Exceptions.Use_Error =>
         Put("handling exception...");
         EKS:=1;
         return;
   end Read_Par;

   procedure Read_P(File_Name: in String; C: out CoNumber;   Decimal: in Boolean := True; Radius: in Boolean:=False; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
      F: File_Type;
   begin
      <<REREAD>> Read_Par(File_Name,C,Decimal,Radius,N);
      if EKS=1 then
         EKS:=0;
         delay 0.01;
         goto REREAD;
      end if;
   end Read_P;

   procedure Write(File_Name: in String; C: in CoNumber;   Decimal: in Boolean := True; Radius: in Boolean:=False) is
      F:  File_Type;
   begin
      Create(F,Out_File,File_Name);
      Put(F,C,Decimal,Radius);
      Close(F);
   end Write;


end CoNumbers.IO;

