with Reps, Reps.Ops, Reps.IO, Messages, Ada.Numerics.Generic_Elementary_Functions,Ada.Characters.Latin_1,Round_Up, Intervals, Intervals.Ops, Intervals.IO;
with RG, RG.Beltrami,CoBalls, CoBalls.Ops, CoBalls.IO, Ada.Text_IO,Ada.Float_Text_IO,  Ada.Command_Line, GetOpt,  Ada.Strings.Unbounded;
use Reps, Reps.Ops, Reps.IO, Messages,Intervals, Intervals.Ops, Intervals.IO, CoBalls, CoBalls.Ops, CoBalls.IO, Ada.Text_IO,Ada.Float_Text_IO, GetOpt, Ada.Command_Line, Ada.Strings.Unbounded;

pragma Elaborate_All(Intervals.Ops);
pragma Elaborate_All(CoBalls.Ops,CoBalls.IO);
pragma Elaborate_All(Reps.Ops);
pragma Elaborate_All (RG);

procedure Fixed_Point is

   pragma Suppress(Storage_Check);

   Pdeg:constant Positive:=3000;
   Dho: constant Natural:=3000;
   subtype Scalar is Interval;
   subtype Comp is CoBall;

   package Current_RG is new RG(Pdeg,Dho,Scalar,Comp);
   use Current_RG, Current_RG.RG_Tay, Current_RG.RG_Tay_Ops, Current_RG.RG_Tay_IO, Current_RG.RG_Lin;

   package Current_Beltrami is new Current_RG.Beltrami;
   use Current_Beltrami;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;

   Test_String : String := "x:k:t:o:p:q:r:e:i:l:j:z:c:";
   Pex,Roo,NumErr: Rep;
   Co,Q,Cut_Output,Np1,Np2,Write_M,Write_E,Va,K,Num_Of_Machines_Bel,This_Machine: Integer;
   Optchar : character;
   Out_Dir: Unbounded_String;
   ShowErr,Compute: Boolean;
   GetPoly: constant Boolean:=True;
   Decimal: constant Boolean:=False;
   Write_Extra:  Boolean:=True;
   Write_Mult:  Boolean:=True;
begin
   --DEAFULT OPTIONS
   K:=1;
   This_Machine:=1;
   Cut_Output:=6;
   Out_Dir:=To_Unbounded_String("/users/denis/Output/example/");
   Pex:=Rep(2.1);
   Rho:=Rep(10.0);
   NumErr:=Rep(1.0E-5);
   Q:=1;

   --OPTIONS
   Getopt.Opterr := 1;
   loop
      Va := Getopt.Getopt( Test_String );
      exit when Va = -1;
      optchar :=  Character'Val( Va );
      case optchar is
         when 'o' =>
            Out_Dir:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'l' =>
            Cut_Output:=Integer'Value(To_String(Getopt.Optarg));
         when 'i' =>
            Write_E:=Integer'Value(To_String(Getopt.Optarg));
         when 'j' =>
            Write_M:=Integer'Value(To_String(Getopt.Optarg));
         when 'x' =>
            Num_Of_Machines_Bel:=Integer'Value(To_String(Getopt.Optarg));
         when 'c' =>
            Co:=Integer'Value(To_String(Getopt.Optarg));
         when 'k' =>
            K:=Integer'Value(To_String(Getopt.Optarg));
         when 't' =>
            This_Machine:=Integer'Value(To_String(Getopt.Optarg));
         when 'p' =>
            Pex:=Rep'Value(To_String(Getopt.Optarg));
         when 'e' =>
            NumErr:=Rep'Value(To_String(Getopt.Optarg));
         when others =>
            New_Line;
            Message("Wrong option in Fixed_Point",Parameter_Error);
      end case;
   end loop;

   --UPDATING OPTIONS
   if Write_E=1 then
      Write_Extra:=True;
   elsif Write_E=0 then
      Write_Extra:=False;
   else
      New_Line;
      Message("Wrong write additional files  option in Fixed_Point",Parameter_Error);
   end if;
   if Write_M=1 then
      Write_Mult:=True;
   elsif Write_M=0 then
      Write_Mult:=False;
   else
      New_Line;
      Message("Wrong write mu*(h*+1) option in Fixed_Point",Parameter_Error);
   end if;
   if Co=1 then
      Compute:=True;
   elsif Co=0 then
      Compute:=False;
   else
      New_Line;
      Message("Wrong option in Fixed_Point",Parameter_Error);
   end if;
   declare
      CM: String:=Set_Machine(This_Machine,Num_Of_Machines_Bel);

      Dir: String:=To_String(Out_Dir);
      Tay_File: String:=Dir & "taylor";
      Radial_Grid: String:=Dir & "rads/radii";
      RadScal_Grid: String:=Dir & "rads/thick_radii";
      Rho_Grid: String:=Dir & "rads/rhos";
      Con_File: String:=Dir & "con_file";
      P_File: String:=Dir & "points/periodic_point";
      Cr_File: String:=Dir & "points/cr_point";
      Cn_File: String:=Dir & "points/cn_point";
      Cn2_File: String:=Dir & "points/cn2_point";
      Cn2n_File: String:=Dir & "points/cn2n_point";
      Approx_H_File: String:=Dir & "h/approx_h_" & CM;
      H_File: String:=Dir & "h/h_" &  CM;
      Mult_File: String:=Dir & "mult/mult_" & CM;
      Small_Belt_File: String:=Dir & "beltrami/belt_" & CM;
      Diff_File: String:=Dir & "h/diff_" & CM;
      Data_File: String:=Dir & "data/data_" & CM;
      Diff_Norm_File: String:=Dir & "data/diff_norm_" & CM;
      Delta1_File: String:=Dir & "data/delta1_" &  CM;
      Delta2_File: String:=Dir & "data/delta2_" &  CM;
      DiffLpNorm,VarEpsilon,ConstK,Radd,Delt1,Delt2: Scalar;
      Qnmin1,Qnmin2,Qnplus1,Qnplus2,RN1,RN2,RoN2: Integer;
      F,F1,F2: File_Type;
      Tay: Taylor;

      N1: constant Integer:=Read_N1(Radial_Grid);
      N2: constant Integer:=Read_N2(Radial_Grid);
      M: constant Integer:=Read_M(Radial_Grid)+5;
      K1: constant Integer:=2-(M-1)/2;
      K2: constant Integer:=(M-1)/2+2;
   begin
      New_Line;
      ShortPut(This_Machine);Put("-TH MACHINE OUT OF ");ShortPut(Num_Of_Machines_Bel);

      Qnmin1:=0;
      Qn:=1;
      Qnplus1:=2;
      Qnplus2:=3;
      for I in 2..K loop
         if I=2 then
            Qnmin2:=0;
            Qnmin1:=1;
            Qn:=2;
            Qnplus1:=3;
            Qnplus2:=5;
         else
            Qnmin2:=Qnmin1;
            Qnmin1:=Qn;
            Qn:=Qnmin2+Qnmin1;
            Qnplus1:=Qn+Qnmin1;
            Qnplus2:=Qnplus1+Qn;
         end if;
      end loop;

      --READING TAYLOR
      New_Line;
      Put("Reading the fixed point ...");
      Read(Tay_File,Rho,Tay,GetPoly,Decimal);
      Put("done");
      New_Line;
      Put("The Taylor series:");
      New_Line;
      Show(Tay);
      New_Line;

      --READING AND COMPUTING POINTS
      New_Line;
      Put("Reading points ...");
      ShowErr:=True;
      Read(P_File,P,Decimal,ShowErr);
      Read(Cn2_File,Cn2,Decimal,ShowErr);
      Read(Cn2n_File,Cn2n,Decimal,ShowErr);
      LogB:=ResetErr(Neg(CoI)*Log(CoOne-P/Cn2));--image of C_{n+2} under inverse tau
      LogA:=Center(AbsVal( Log(  (Cn2n-P)*Cn2/((Cn2-P)*Cn2n)  )  ));
      LogBB:=LogB;
      Put(" done");

      --READING THE DIMENSIONS OF THE  RADIAL GRID
      New_Line;
      Put("Reading the dimensions of the grid ...");
      if This_Machine=1 then
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=N1+This_Machine*Integer((-N1)/Num_Of_Machines_Bel)-1;
         RN1:=Np1;RN2:=Np2+1;RoN2:=RN2;
      elsif This_Machine=Num_Of_Machines_Bel then
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=0;
         RN1:=Np1-1;RN2:=N2;RoN2:=0;
      else
         Np1:=N1+(This_Machine-1)*Integer((-N1)/Num_Of_Machines_Bel);
         Np2:=N1+This_Machine*Integer((-N1)/Num_Of_Machines_Bel)-1;
         RN1:=Np1-1;RN2:=Np2+1;RoN2:=RN2;
      end if;
      Put(" done");

      declare
         Rad,ThickRad: ScalArray(RN1..RN2);
         Ro: ScalArray(RN1-1..RoN2);
         H: CompMatrix(Np1..Np2,K1..K2);
         V: CompArray(K1..K2);
         H1Sup,Delta1,Delta2: ScalArray(Np1..Np2);
         RoDiff,LpSum,EsSup: Scalar;
      begin

         --READING THE RADIAL GRID
         New_Line;
         Put("Reading grid ...");
         Open(F,In_File,Radial_Grid);
         Open(F1,In_File,RadScal_Grid);
         Open(F2,In_File,Rho_Grid);
         Set_Line(F,Ada.Text_IO.Count(2+RN1-N1));
         Set_Line(F1,Ada.Text_IO.Count(2+RN1-N1));
         Set_Line(F2,Ada.Text_IO.Count(2+RN1-N1));
         for I in Rad'Range loop
            Txt_Get(F,Roo,Decimal);
            Rad(I):=Scal(Roo);
            Get(F1,Radd,Decimal);
            ThickRad(I):=Radd;
         end loop;
         for I in Ro'Range loop
            Txt_Get(F2,Roo,Decimal);
            Ro(I):=Scal(Roo);
         end loop;
         Close(F2);
         Close(F1);
         Close(F);
         Put("done");


         --WORKING WITH THE APPROXIMATION
         New_Line;
         Put("Reading an approximation...");
         --ShowErr:=False;
         Read_SB(H,Approx_H_File,False,False,Decimal,ShowErr);
         --Read_Part(H,Approx_H_File,False,False,Decimal,ShowErr); --reading an approximation
         Put(" done");


         --DISPLAYING INFO
         New_Line;
         New_Line;
         Put("q_n=");ShortPut(Qn);
         New_Line;
         Put("p=");Show(P);
         New_Line;
         Put("f^(q_(n+2))(c)=");Show(Cn2);
         New_Line;
         Put("f^(q_(n+2)+q_n)(c)=");Show(Cn2n);
         New_Line;
         Put("Maximal radius of the grid=");Show(Rad(Rad'Last));
         Put("Radial grid dimensions=(");ShortPut(N1);Put(",");ShortPut(N2);Put(")");
         New_Line;
         Put("Angular grid dimensions=(");ShortPut(K1);Put(",");ShortPut(K2);Put(")");
         New_Line;
         Put("Radial grid dimensions on this machine=(");ShortPut(Np1);Put(",");ShortPut(Np2);Put(")");
         New_Line;
         Put("Maximal radius on this machine=");Show(Rad(Np2));
         Put("Minimal radius on this machine=");Show(Rad(Np1));

         Create(F,Out_File,Dir & "logs/start_" & CM);
         Put(F,0);
         Close(F);

         if not Write_Mult then
            goto JUMP;
         end if;

         --READING THE BELTRAMI DIFFERENTIAL
         New_Line;
         Put("Computing the Beltrami differential and multiplying...");
         if This_Machine=1 and This_Machine<=(Num_Of_Machines_Bel) then
            Simple_ProdAddBeltramiF(NumErr,Pex,Ro,ThickRad,Tay,H,Delta1,Delta2,ConstK,VarEpsilon);
         else
            Simple_ProdAddBeltrami(NumErr,Pex,Ro,ThickRad,Tay,H,Delta1,Delta2,ConstK,VarEpsilon);
         end if;
         Put("done");
         New_Line;
         Put("ESSENTIAL SUPREMUM OF mu=");Show(ConstK);
         if  Write_Mult then
            New_Line;
            Put("Writing mu*(h*+1)...");
            ShowErr:=True;
            Write_SB(H,Mult_File,Decimal,ShowErr); --series
            Put(" done");
         end if;
         Put("Calculating ||eta*(h*+1)||^p_p...");
         EssSup(H,H1Sup);
         Delt1:=ScalZero;
         Delt2:=ScalZero;
         for I in H1Sup'Range loop
            Delt1:=Delt1+Exp(Pex*Log(H1Sup(I)))*Delta1(I);
            Delt2:=Delt2+Exp(Pex*Log(H1Sup(I)))*Delta2(I);
         end loop;
         Put("done");
         New_Line;
         Put("||eta*(h*+1)||^p_p=");Show(Delt1);


         Create(F,Out_File,Data_File);
         New_Line;
         Put("Writing the rest of the data...");
         Put(F,Delt1,Decimal);--||eta*(h*+1)||^p_p
         New_Line(F);
         Put(F,Delt2,Decimal);--||eta*(h*+1)||^p_p
         New_Line(F);
         Put(F,ConstK,Decimal);-- essential supremum of mu
         New_Line(F);
         Put(F,VarEpsilon,Decimal);-- L_p error in multiplication
         Close(F);
         Put("done");


         <<JUMP>> if not Write_Mult then
               New_Line;
               Put("Reading h*(mu+1)...");
               ShowErr:=True;
               Read_SB(H,Mult_File,False,False,Decimal,ShowErr);
               Put("done");
         end if;

         --ITERATION
         ShowErr:=True;
         if Compute then 
           Iter_Fixed_Point(Pex,N1,Num_Of_Machines_Bel,This_Machine,Cut_Output,H,Rad,ThickRad,Ro,CoZero,Dir,True,Decimal,ShowErr);
         else
           New_Line;
           Put("Reading h...");
           Read_SB(H,H_File,False,False,Decimal,ShowErr);
           Put("done");
         end if;

         --NORM OF THE DIFFERENCE
         New_Line;
         Put("Calculating || h*-T[(h*+1)*mu]||_p...");
         ShowErr:=True;
         DiffLpNorm:=ScalZero;
         Open(F,In_File,Approx_H_File);
         Set_Line(F,Ada.Text_IO.Count(2));
         for I in H'Range(1) loop
            RoDiff:=(Ro(I)-Ro(I-1))*(Ro(I)+Ro(I-1));
            LpSum:=ScalZero;
            EsSup:=ScalZero;
            --New_Line;
            for J in H'Range(2) loop
               Get(F,V(J),Decimal,ShowErr);
               EsSup:=EsSup+AbsVal(H(I,J)-V(J));
               LpSum:=LpSum+Sqr(AbsVal(H(I,J)-V(J)));
               --               New_Line;Put("(h-h*)("); ShortPut(J);Put(")"); Show(H(I,J)-V(J));
            end loop;
            for J in (H'Last(2)-4)..H'Last(2) loop
               EsSup:=EsSup+AbsVal(H(I,J));
               LpSum:=LpSum+Sqr(AbsVal(H(I,J)));
               --               New_Line; Put("(h-h*)("); ShortPut(J);Put(")"); Show(H(I,J));
            end loop;
            DiffLpNorm:=DiffLpNorm+Exp((Pex-Two)*Log(Scal(Sup(EsSup))))*ScalPi*RoDiff*LpSum;
         end loop;
         Close(F);
         Put("done");
         if Write_Extra and Compute then
            New_Line;
            Put("Writing h*...");
            ShowErr:=True;
            Write_SB(H,H_File,Decimal,ShowErr); --series
            Put(" done");
         end if;

         --WRITING DATA
         New_Line;
         Put("Writing the rest of the data...");
         Create(F,Out_File,Diff_Norm_File);
--         Set_Line(F,Ada.Text_IO.Count(1));
         Put(F,DiffLpNorm,Decimal);--|| h*-T[(h*+1)*mu]||^p_p
         Close(F);
         Put("done");
      end;
   end;
end Fixed_Point;



























