with Messages, Reps.IO, Ada.IO_Exceptions;
use Messages, Reps.IO;

package body Numerics.IO is

  procedure Show(S: in Numeric; NewLine: in Boolean := True) is
  begin
    Txt_Put(Current_Output,Rep(S),True);
    if NewLine then New_Line; end if;
  end Show;

  procedure Get(F: in File_Type; S: out Numeric; Decimal: in Boolean := True) is
    R1,R2: Rep;
  begin
    Txt_Get(F,R1,R2,Decimal);
    S := Numeric(R1);
  end Get;

  procedure Put(F: in File_Type; S: in Numeric; Decimal: in Boolean := True) is
  begin
    Txt_Put(F,Rep(S),Decimal);
  end Put;

  procedure Read(File_Name: in String; S: out Numeric;   Decimal: in Boolean := True) is
     F: File_Type;
  begin
     Open(F,In_File,File_Name);
     Get(F,S,Decimal);
     Close(F);
  end Read;

  procedure Write(File_Name: in String; S: in Numeric;   Decimal: in Boolean := True) is
     F: File_Type;
  begin
      Create(F,Out_File,File_Name);
      Put(F,S,Decimal);
      Close(F);
  end Write;

  procedure Read(File_Name: in String; S: out Numeric;   Decimal: in Boolean := True; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
     F: File_Type;
  begin
     Open(F,In_File,File_Name);
     Set_Line(F,N);
     Get(F,S,Decimal);
     Close(F);
  end Read;

  procedure Read_Par(File_Name: in String; S: out Numeric;   Decimal: in Boolean := True; N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
     F: File_Type;
  begin
     if EKN=1 then
        New_Line;
        Put("Handle is not reset");Message("Numerics.IO.Read_Par",Parameter_Error);
     end if;
      Open(F,In_File,File_Name);
      Set_Line(F,N);
      Get(F,S,Decimal);
      Close(F);
  exception
      when Ada.Text_IO.End_Error  =>
         Close(F);
         Put("handling exception...");
         EKN:=1;
         return;
     when Ada.IO_Exceptions.Data_Error =>
         Close(F);
         Put("handling exception...");
         EKN:=1;
         return;
      when Ada.IO_Exceptions.Name_Error  =>
         Put("handling exception...");
         EKN:=1;
         return;
     when  Ada.IO_Exceptions.Status_Error =>
         Close(F);
         Put("handling exception...");
         EKN:=1;
         return;
      when  Ada.IO_Exceptions.Use_Error =>
         Put("handling exception...");
         EKN:=1;
         return;
   end Read_Par;

   procedure Read_P(File_Name: in String; S: out Numeric;   Decimal: in Boolean := True;N: in Ada.Text_IO.Count:=Ada.Text_IO.Count(1)) is
      F: File_Type;
   begin
      <<REREAD>> Read_Par(File_Name,S,Decimal,N);
      if EKN=1 then
         EKN:=0;
         delay 0.01;
         goto REREAD;
      end if;
   end Read_P;

end Numerics.IO;
