with Reps, Reps.Ops, Reps.IO, Messages,
  Ada.Numerics.Generic_Elementary_Functions,Ada.Characters.Latin_1,Round_Up,  Ada.Text_IO,Ada.Float_Text_IO,  Ada.Command_Line, GetOpt,  Ada.Strings.Unbounded;
--with CoBalls, CoBalls.Ops, CoBalls.IO, Intervals, Intervals.Ops, Intervals.IO;
--use Intervals, Intervals.Ops, Intervals.IO, CoBalls, CoBalls.Ops, CoBalls.IO;
with RG, RG.Beltrami, CoNumbers, CoNumbers.Ops, CoNumbers.IO, Numerics, Numerics.Ops, Numerics.IO;
use CoNumbers, CoNumbers.Ops, CoNumbers.IO, Numerics, Numerics.Ops, Numerics.IO;
use Reps, Reps.Ops, Reps.IO, Messages, Ada.Text_IO,Ada.Float_Text_IO, GetOpt, Ada.Command_Line, Ada.Strings.Unbounded;

--pragma Elaborate_All(Intervals.Ops);
--pragma Elaborate_All(CoBalls.Ops,CoBalls.IO);
pragma Elaborate_All(Numerics.Ops);
pragma Elaborate_All(CoNumbers.Ops,CoNumbers.IO);

pragma Elaborate_All(Reps.Ops);
pragma Elaborate_All (RG);

procedure Renorm is

   pragma Suppress(Storage_Check);

   Pdeg:constant Positive:=1000;
   Dho: constant Natural:=1000;
   --   subtype Scalar is Interval;
   --   subtype Comp is CoBall;
   subtype Scalar is Numeric;
   subtype Comp is CoNumber;

   package Renorm_RG is new RG(Pdeg,Dho,Scalar,Comp);
   use Renorm_RG, Renorm_RG.RG_Tay, Renorm_RG.RG_Tay_Ops, Renorm_RG.RG_Tay_IO, Renorm_RG.RG_Lin;

   package Renorm_Beltrami is new Renorm_RG.Beltrami;
   use Renorm_Beltrami;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   Test_String : String := "a:b:c:d:o:r:n:p:x:k:q:s:t:f:l:z:i:g:j:";
   Pex,X0,Y0,NumErr: Rep;
   MDim,II1,II2,Except_Machine,I1,I2,K,Va,Num_Of_Machines_Coord,Num_Of_Machines_Bel,This_Machine,Cont_Length: Integer;
   --Rad: Scalar;
   DerRenTay: Taylor;
   Optchar : character;
   In_Cont_Dir,Tay_File,RenTay_File,Out_Dir,Newton_Map_File,Column_File: Unbounded_String;
   IsPoly: constant Boolean:=True;
   ShowErr: Boolean:=False;
   GetPoly: constant Boolean:=True;
   PutPoly: constant Boolean:=True;
   Decimal: constant Boolean:=True;
   F: File_Type;
   Except_Machine_File: String:="except_machine";
   II1_File: String:="ii1";
   II2_File: String:="ii2";
   CM: String:="02";
 begin
   --DEAFULT OPTIONS
   K:=1;
   NumErr:=Rep(1.0E-9);
   Out_Dir:=To_Unbounded_String("~/numerics_data/");
   Tay_File:=To_Unbounded_String("~/numerics_data/taylor");
   RenTay_File:=To_Unbounded_String("~/numerics_data/ren_taylor");
   Newton_Map_File:=To_Unbounded_String("~/numerics_data/data/newton_map");
   Column_File:=To_Unbounded_String("~/numerics_data/matrix/column_");
   MDim:=13;
   Rho:=Rep(2.2);
   --Radd:=Rep(2.2);
   Pex:=Rep(2.2);

   --OPTIONS
   Getopt.Opterr := 1;
   loop
      Va := Getopt.Getopt( Test_String );
      exit when Va = -1;

      optchar :=  Character'Val( Va );
      case optchar is
         when 'a' =>
            X0:=Rep'Value(To_String(Getopt.Optarg));
         when 'b' =>
            Y0:=Rep'Value(To_String(Getopt.Optarg));
         when 'o' =>
            Out_Dir:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'd' =>
            In_Cont_Dir:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'n' =>
            NumErr:=Rep'Value(To_String(Getopt.Optarg));
         when 'p' =>
            RenTay_File:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'i' =>
            Newton_Map_File:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'g' =>
            Column_File:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'f' =>
            Tay_File:=To_Unbounded_String(To_String(Getopt.Optarg));
         when 'r' =>
            Rho:=Rep'Value(To_String(Getopt.Optarg));
--         when 's' =>
--            Radd:=Rep'Value(To_String(Getopt.Optarg));
         when 'k' =>
            K:=Integer'Value(To_String(Getopt.Optarg));
         when 'l' =>
            Cont_Length:=Integer'Value(To_String(Getopt.Optarg));
         when 'x' =>
            Num_Of_Machines_Coord:=Integer'Value(To_String(Getopt.Optarg));
         when 'z' =>
            Num_Of_Machines_Bel:=Integer'Value(To_String(Getopt.Optarg));
         when 't' =>
            This_Machine:=Integer'Value(To_String(Getopt.Optarg));
         when 'j' =>
            MDim:=Integer'Value(To_String(Getopt.Optarg));
         when others =>
            New_Line;
            Message("Wrong option in Renorm",Parameter_Error);
      end case;
   end loop;

   --Rad:=Scal(Radd);
   Open(F,In_File,To_String(In_Cont_Dir) & Except_Machine_File);
   Get(F,Except_Machine);
   Close(F);
   Open(F,In_File,To_String(In_Cont_Dir) & II1_File);
   Get(F,II1);
   Close(F);
   Open(F,In_File,To_String(In_Cont_Dir) & II2_File);
   Get(F,II2);
   Close(F);

   --SETTING THE CONTOUR DIMENSIONS
   SetCont(Cont_Length,This_Machine,Num_Of_Machines_Coord,I1,I2);
   if This_Machine=Except_Machine then I2:=II2; end if;
   if This_Machine=Except_Machine+1 then I1:=II1; end if;
   New_Line;
   Put("This machine works with the following range in the contour arrays: [");ShortPut(I1);Put(",");ShortPut(I2);Put("]");

   declare

      --FILE AND DIRECTORY NAMES
      CM: String:=Set_Machine(This_Machine,Num_Of_Machines_Coord);
      Dir: String:=To_String(Out_Dir);
      Cont_Dir: String:=To_String(In_Cont_Dir);
      RadScal_Grid: String:=Dir & "rads/new_radii";
      Rad_Grid: String:=Dir & "rads/new_radii";
      P_File: String:=Dir & "tau_points/periodic_point";
      Cr_File: String:=Dir & "tau_points/cr_point";
      Centre_File: String:=Dir & "tau_points/centre_point";
      HCentre_File: String:=Dir & "tau_points/hcentre_point";
      Cn2_File: String:=Dir & "tau_points/cn2_point";
      Cn2n_File: String:=Dir & "tau_points/cn2n_point";
      SolZeroVal_File: String:=Dir & "points/sol_val_at_zero";
      C_File: String:=Dir & "data/C_file";
      R_File: String:=Dir & "data/R_file";
      A_File: String:=Dir & "data/A_file";
      EP_File: String:=Dir & "Eps_file";
      Sol_File: String:=Dir & "g/approx_g_";

      Coord_File: String:=Cont_Dir & "coordinate_";
      FCoord_File: String:=Cont_Dir & "fcoordinate_";

      Rad_File: String:=Cont_Dir & "radius_";
      FRad_File: String:=Cont_Dir & "fradius_";

      TCoord_Centre_File: String:=Cont_Dir & "tcoord_centre_";
      TFCoord_Centre_File: String:=Cont_Dir & "tfcoord_centre_";

      Ren_Cont_File: String:=Dir & "contours/ren_cont_file";
      Ren_FCont_File: String:=Dir & "contours/ren_fcont_file";

      NRen_Cont_File: String:=Dir & "contours/normed_ren_cont_file";
      NRen_FCont_File: String:=Dir & "contours/normed_ren_fcont_file";

      TCont_File: String:=Cont_Dir & "tcont_file_";
      TFCont_File: String:=Cont_Dir & "tfcont_file_";

      GCont_File: String:=Cont_Dir & "gcont_file_";
      GFCont_File: String:=Cont_Dir & "gfcont_file_";

      New_GCont_File: String:=Dir & "contours/gcont_file_";
      New_GFCont_File: String:=Dir & "contours/gfcont_file_";


      --REST OF VARIABLES
      Qnmin1,Qnmin2,Qnplus1,Qnplus2: Integer;
      N1: constant Integer:=Read_N1(RadScal_Grid);
      N2: constant Integer:=Read_N2(RadScal_Grid);
      M: constant Integer:=Read_M(RadScal_Grid);
      K1: constant Integer:=-M/2;
      K2: constant Integer:=M/2-1;

      TR,Coord_Rad,FCoord_Rad,NM_Diff,M_Norm,Clmn_Norm,Ball_Rad: Rep;
      T: Scalar;
      R: Scalar:=ScalZero;--does not matter for the numerics
      AEP: Scalar:=ScalZero; --does not matter for the numerics
      ConstC: Scalar:=ScalZero; --does not matter for the numerics

      Val_At_Zero,Cr,GCr,Centre,TCoord_Centre,HCentre,TFCoord_Centre,C1,C2: Comp;

      F0,F1,F11,F12,F2,F3,F4,F5,F6,F7,F8,F9,F10,F13: File_Type;

      RenTay,Tay,Coord,FCoord: Taylor;

      Columns: TayArray(2..MDim);
      ThickRad: ScalArray(N1..N2);
      V1,V2: CompArray(K1..K2);
      TCont,TFCont,GCont,GFCont: CompArray(I1..I2);
      Ren_Cont,Ren_FCont:  CompArray(1..Cont_Length);
   begin

      --SETTING THE ORDER OF RENORMALIZATIUON
      Qnmin1:=0;
      Qn:=1;
      Qnplus1:=2;
      Qnplus2:=3;
      for I in 2..K loop
         if I=2 then
            Qnmin2:=0;
            Qnmin1:=1;
            Qn:=2;
            Qnplus1:=3;
            Qnplus2:=5;
         else
            Qnmin2:=Qnmin1;
            Qnmin1:=Qn;
            Qn:=Qnmin2+Qnmin1;
            Qnplus1:=Qn+Qnmin1;
            Qnplus2:=Qnplus1+Qn;
         end if;
      end loop;

      --READING THE GRID
      New_Line;
      Put("Reading grid ...");
      Open(F,In_File,RadScal_Grid);
      Set_Line(F,Ada.Text_IO.Count(2));
      for I in N1..N2 loop
         Txt_Get(F,TR);
         ThickRad(I):=Scal(TR);
--         if TR>=Radd and TR<=Radd then
--            Ind:=I;
--         end if;
      end loop;
      Close(F);
      Put("done");

--      for I in 1..This_Machine loop
--         delay 2.0;
--      end loop;


      --READING TAYLOR
      New_Line;
      Put("Reading the fixed point ...");
      Read_P(To_String(Tay_File),Rho,Tay,GetPoly,Decimal);
      Put(" done");

      --READING AND COMPUTING POINTS
      New_Line;
      Put("Reading points ...");
      Read_P(P_File,P,Decimal,ShowErr);
      Read_P(Cr_File,Cr,Decimal,ShowErr);
      Read_P(Centre_File,Centre,Decimal,ShowErr);
      Read_P(HCentre_File,HCentre,Decimal,ShowErr);
      Read_P(Cn2_File,Cn2,Decimal,ShowErr);
      Read_P(Cn2n_File,Cn2n,Decimal,ShowErr);
      Read_P(SolZeroVal_File,Val_At_Zero,Decimal,ShowErr);
      LogB:=Neg(CoI)*Log(CoOne-P/Cn2);--image of C_{n+2} under inverse tau
      LogA:=AbsVal( Log(  (Cn2n-P)*Cn2/((Cn2-P)*Cn2n)  )  );
      LogBB:=LogB;
      Put(" done");

      --READING AND CONSTRUCTING REENORMALIZATION CONTOURS
      New_Line;
      Put("Reading and computing g-contours...");
      Read_Vector(TCont_File & CM,TCont,Decimal,ShowErr);
      Read_Vector(TFCont_File & CM,TFCont,Decimal,ShowErr);
      Read_P(Rad_File & CM,Coord_Rad,Decimal);
      Read_P(Coord_File & CM,Coord_Rad,Coord,GetPoly,Decimal);
      Read_P(FRad_File & CM,FCoord_Rad,Decimal);
      Read_P(FCoord_File & CM,FCoord_Rad,FCoord,GetPoly,Decimal);
      Read_P(TCoord_Centre_File & CM,TCoord_Centre,Decimal,ShowErr);
      Read_P(TFCoord_Centre_File & CM,TFCoord_Centre,Decimal,ShowErr);
      Create(F1,Out_File,GCont_File & CM);
      Create(F2,Out_File,GFCont_File & CM);
      Create(F3,Out_File,New_GCont_File & CM);
      Create(F4,Out_File,New_GFCont_File & CM);
      for J in TCont'Range loop
         GCont(J):= Val(1,Coord_Rad,TCont(J)-TCoord_Centre,Coord);
         GFCont(J):= Val(1,FCoord_Rad,TFCont(J)-TFCoord_Centre,FCoord);
         Put(F1,GCont(J),Decimal,False);
         New_Line(F1);
         Put(F2,GFCont(J),Decimal,False);
         New_Line(F2);

         GetRow(Num_Of_Machines_Bel,ThickRad,Sol_File,AbsVal(GCont(J)),V1,V2,T,Decimal,ShowErr);
         GCont(J):=G_Value(Pex,R,AEP,ConstC,V1,V2,Val_At_Zero,GCont(J),T,AbsVal(GCont(J)),Arg(GCont(J)));
         GetRow(Num_Of_Machines_Bel,ThickRad,Sol_File,AbsVal(GFCont(J)),V1,V2,T,Decimal,ShowErr);

         GFCont(J):=G_Value(Pex,R,AEP,ConstC,V1,V2,Val_At_Zero,GFCont(J),T,AbsVal(GFCont(J)),Arg(GFCont(J)));
         Put(F3,GCont(J),Decimal,False);
         New_Line(F3);
         Put(F4,GFCont(J),Decimal,False);
         New_Line(F4);

      end loop;
      Close(F1);
      Close(F2);
      Close(F3);
      Close(F4);
      Put("done");

      if This_Machine/=Num_Of_Machines_Coord then
         return;
      end if;

--      delay 100.0;

      New_Line;
      Put("Computing the renormalization contours...");
      Create(F1,Out_File,Ren_Cont_File);
      Create(F2,Out_File,Ren_FCont_File);
      for I in 1..Num_Of_Machines_Coord loop
         SetCont(Cont_Length,I,Num_Of_Machines_Coord,I1,I2);
         if I=Except_Machine then I2:=II2; end if;
         if I=Except_Machine+1 then I1:=II1; end if;
         CM:=Set_Machine(I,Num_Of_Machines_Coord);

         Open(F3,In_File,New_GCont_File & CM);
         Open(F4,In_File,New_GFCont_File & CM);
         for J in I1..I2 loop
            Get(F3,C1,Decimal,ShowErr);
            Get(F4,C2,Decimal,ShowErr);
            Ren_Cont(J):=C1;
            Ren_FCont(J):=C2;
            Put(F1,Ren_Cont(J),Decimal,False);
            New_Line(F1);
            Put(F2,Ren_FCont(J),Decimal,False);
            New_Line(F2);
         end loop;
         Close(F3);
         Close(F4);

      end loop;
      Close(F1);
      Close(F2);
      Put("done");

      --COMPUITING THE TAYLOR SERIES
      New_Line;
      Put("Computing the coefficients in the series...");
      ComputeTay(50,Ren_Cont,Ren_FCont,RenTay);
      Put(" done");
      SetComponent(0,CoZero,RenTay);
      SetComponent(1,CoExpTheta,RenTay);
      Der(Rho,Rep(0.95)*Rho,RenTay,DerRenTay,IsPoly);
      GCr:=Rep(10.0)*CoOne;
      Newton(1,Rho,GCr,DerRenTay,CoZero);

      Create(F1,Out_File,NRen_Cont_File);
      Create(F2,Out_File,NRen_FCont_File);
      for J in Ren_Cont'Range loop
         Put(F1,Ren_Cont(J)/GCr,Decimal,False);
         New_Line(F1);
         Put(F2,Ren_FCont(J)/GCr,Decimal,False);
         New_Line(F2);
      end loop;
      Close(F1);
      Close(F2);

      for I in 2..30 loop
         SetComponent(I,(GCr**(I-1))*Component(I,RenTay),RenTay);
      end loop;
      Der(Rho,Rep(0.95)*Rho,RenTay,DerRenTay,IsPoly);
      GCr:=CoOne;
      Newton(1,Rho,GCr,DerRenTay,CoZero);
      New_Line;
      Put("Critical point of R[f]=");Show(GCr);
      New_Line;
      Put("Renormalized function:");
      Show(RenTay);

      Write(To_String(RenTay_File),RenTay,PutPoly,Decimal);

      New_Line;
      Put("||R(f)||_r=");Txt_Put(Current_Output,Norm(Rho,RenTay));
      New_Line;
      Put("||f-R(f)||_r=");Txt_Put(Current_Output,Norm(Rho,Tay-RenTay));


      -- CALCULATING THE NORM OF M
      M_Norm:=Zero;
      for I in 2..M_Dim loop
        CM:=Set_Machine(I,M_Dim);
        New_Line;
        Put("Reading column ");ShortPut(I); Put(" of M and calculating its norm...");
        Read_P(To_String(Column_File) & CM,Rho,Columns(I),GetPoly,Decimal);
        Clmn_Norm:=Norm(Rho,Columns(I));
        if Clmn_Norm>M_Norm then
          M_Norm:=Clmn_Norm;
        end if;
        Put(" done");
      end loop;
      New_Line;
      Put("|M|=");Txt_Put(Current_Output,M_Norm);
      Ball_Rad:=Sup(Scal(ErrComp(Tay))/M_Norm); --size of the ball in the Newton map

      New_Line;
      Put("Calculating and writing the action of the Newton map...");
      AddErrComp(Ball_Rad,Tay);
      NM_Diff:=Norm(Rho,RenTay-Tay);
      Write(Newton_Map_File,NM_Diff);
      Put("done");
      New_Line;
      Put("||N(z)||_r=");Txt_Put(Current_Output,NM_Diff);
   end;
end Renorm;



























